/* 
 * File:   automata.h
 * Author: snippy
 *
 * Created on June 12, 2008, 10:37 AM
 */

#ifndef _AUTOMATA_H
#define	_AUTOMATA_H

#include <ostream>
#include <map>

class Transition;

class Automata;

class Groupe
	{
public:
	list<Automata*> autos;
	};

class State
	{
public: 
	Automata *automata;
    bool si;
    list<Transition*> step;
    int value;
    State(int v, bool s,Automata *a);
    void addTransition(Transition* t);
    ~State();
    void display(ostream &o);
	};

class Transition
	{
public:
    int* bits; // 0 ou 1 ou -1 (pour '?')
    State* st; // original state
    Transition(State* next, int* b);
	void display(int bits_size);
    ~Transition();
	};

class StatePara
	{
public:
	list<State*> actives;
	};

class ExploPara
	{
public:
	list<StatePara> statePara;
	};

class Automata 
	{
public:
    State* si;
    int cvalue;
	int nvars;
    vector<int> a;
    int eqSize;
	bool isIntersect(Automata *au,int size);
    Automata(Condition* n, std::map <int, int>* numvars);
    Automata(Condition* n);
    ~Automata();
    void display(ostream &o);
	};

#endif	/* _AUTOMATA_H */

