/**
 * Main file of the unificator
 * @author Mathieu Guillame-Bert and Gabriel Synnaeve
 */

#include <stdio.h>
#include <iostream>
#include <fstream>
#include "config.h"
#include "exception.h"
#include "display.h"
#include "parser.h"
#include "unification.h"

int main(int argc, char *argv[])
	{ 
	try
		{
		Configuration *config = globconfig = new Configuration(argc,argv);
		Display::Head(config);
		Parser *parser = new Parser(config);
		Unification *unification = new Unification(config,parser);
		unification->run();
		Display::displayResult(unification);
		Display::Foot(config);
		}
	  catch (exception& e)
  		{
    	cerr << endl << e.what() << endl;
		//getc(stdin);
  		}
	return 0;
	}
