%{

#include <string>

#include "parser.h"
#include "parser.tab.hh"

#undef yywrap
#define yywrap() 1
extern int numLine;

%}

%option noyywrap
%option c++

letter      [a-z]
LETTER      [A-Z]
number      [0-9]
impr        [\040-\176]
Car_imp     [\040-\176]
comment     "#"({Car_imp}|\t)*
blancs			[ \t]+
MotMaj			({LETTER})({letter}|"_"|{number})*
MotMin			({letter})({letter}|"_"|{number})*
MotNum			number+

%% /*** Regular Expressions Part ***/

{comment}  { }

{blancs}  { }

{number}+ {
    yylval.integerVal = atoi(yytext);
    return INT;
}

"run" return(RUN);

"set" return(SET);
"help" return(HELP);

"step" return(STEP);
"info" return(INFO);
"zero" return(ZERO);
"beep" return(BEEP);

"or"   return(OR);

"and"   return(AND);

"OR"   return(OR);

"AND"   return(AND);

{MotNum}	{
		yylval.integerVal = atoi(yytext);
		return(INT);
		}

{MotMaj}	{
		yylval.stringVal = new std::string(yytext);
		return(MAJ);
		}
		
{MotMin}	{
		yylval.stringVal = new std::string(yytext);
		return(MIN);
		}

"=" {
    return EQUAL;
}

"==" {
    return EQUAL2;
}

"(" {
    return LEFT_PAR;
}

")" {
    return RIGHT_PAR;
}

"{" {
    return LEFT_BRA;
}

"}" {
    return RIGHT_BRA;
}

"@" {
    return HOLE;
}

"," {
    return COMMA;
}

"." {
    return DOT;
}

"*" {
    return TIMES;
}

"+" {
    return PLUS;
}

"^" {
    return POWER;
}

[ \t\r]+ {
    
}

"\n" {
    numLine++;
    return EOL;
}
