#ifndef SOLVER_H
#define SOLVER_H

#include <list>
#include <vector>
#include "unification.h"
#include <ostream>
using namespace std;

namespace Solver
	{
class Vertex;
class Edge;

	class VariableSolution
		{
	public:
		bool seeoutside;
		Node *definition;
		};

	class Edge
		{
	public:
		Vertex *n1;
		Vertex *n2;
		int a;
		int b;
		};

	class Vertex
		{
	public:
		list<Edge*> in;
		list<Edge*> out;
		int variable;
		int count;
		int min;
		int max;
		bool setBounds(int min,int max);
		bool setBoundMin(int min);
		bool setBoundMax(int max);

		Edge *father;
		bool visited;
		};

	class Contribution
		{
	public:
		Vertex *v;
		float a;
		};

	class SolverSolution : public Solution
		{
	public:
		Unification *unification;
		VariableSolution *variableSolution;
		unsigned int ndvar;
		bool success;
		void display(ostream &o);
		bool check();
		};

	class Graph
		{
	public:
		SolverSolution *solus;
		Unification *unification;
		bool success;
		list<Vertex*> vertexs;
		list<Edge*> edges;
		Graph(Node* node,Unification *unification);
		bool explo(Node* n);
		SolverSolution *run();
		~Graph();
		bool seekCycle(list<Vertex*> &ver,list<Edge*> &ed);
		void resetVisited();
			void print();

		Vertex* addVertex(int id);
		Edge* addEdge(Vertex *v1,Vertex *v2,int a,int b);
		};

	};

#endif

