#ifndef UNIFICATION_H
#define UNIFICATION_H

#include "parser.h"
#include "config.h"
#include <ostream>

class Unification;

class Solution
	{
public:
	virtual void display(ostream &o) = 0;
	virtual bool check() = 0;
	};

class VariableSolution
	{
public:
	VariableSolution();
	bool seeoutside;
	Node *definition;
	list<Condition*> definitionc;
	};

class SimpleSolution : public Solution
	{
public:
	Unification *unification;
	bool fail;
	unsigned int ndvar;
	unsigned int ndnumvar;
	VariableSolution *variableSolution;
	VariableSolution *numericalvariableSolution;
	SimpleSolution(unsigned int ndvar,unsigned int ndnumvar,Unification *unification);
    ~SimpleSolution();
	void display(ostream &o);
	bool check();
	};

class Unification
	{
public:
	Configuration *configuration;
	Parser *parser;
	bool result;
	
	list<Solution*> solutions;
	
	Unification(Configuration *configuration,Parser *parser);
	void run();
	Node* ApplyR0(Node *start=NULL);
	bool tryApplyR1();
	bool tryApplyR2();
	bool tryApplyR3();
	bool tryApplyR4();
	bool tryApplyR5();
	Node* SetDisjunctiveSystem(Node *start = NULL);
	bool checkDefinition();
	void debugDisplay(ostream &s);
	bool exploDefinition(Node *n, SimpleSolution *solution);
	bool verifValidPresburger(Node *n);
	~Unification();

	static int gcd(unsigned int a,unsigned int b);
	static bool prefix(const list<unsigned int> &l1,const list<unsigned int> &l2);
	static list<unsigned int> append(const list<unsigned int> &l1,const list<unsigned int> &l2);

	};

#endif

